
Ruby - Feature #1031

-U オプションの説明が --help にない

01/21/2009 07:02 PM - sakuro (Sakuro OZAWA)

Status: Rejected   

Priority: Normal   

Assignee: matz (Yukihiro Matsumoto)   

Target version: 2.0.0   

Description

=begin

irbのほうに

-U                Same as ruby -U

-U                ruby -U と同じ.

とある以上、本体にもあるべき?

$ ruby19 --version

ruby 1.9.1p0 (2009-01-20 revision 21700) [i386-darwin9.6.0]

$ ruby19 --help

Usage: ruby19 [switches] [--] [programfile] [arguments]

-T[level]       turn on tainting checks

-v              print version number, then turn on verbose mode

=end

History

#1 - 01/21/2009 08:19 PM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Rejected

=begin

manを読めばいいと思いますね。

=end

#2 - 01/21/2009 08:55 PM - akira (akira yamada)

=begin

On 2009/01/21, at 20:18, Shyouhei Urabe wrote:

manを読めばいいと思いますね。

http://redmine.ruby-lang.org/issues/show/1031

 manpageに書いてあるから--helpの出力には含めることができない、

ということでしょうか?

=end

#3 - 01/21/2009 10:59 PM - naruse (Yui NARUSE)

=begin

ruby --help の結果は1画面に収まるべきであるという要求があったのと、

基本的に余計な情報は表には出さないという方針と、

両方の理由から特に --help に載せるべきものは厳選される傾向にあります。

=end

#4 - 01/22/2009 01:56 PM - duerst (Martin Dürst)

=begin

「1画面」の定義は何でしょうか。今の時代には「画面」のサイズは

どんどん多様化しています。従来のサイズだったら 24x80 ではないか

と思いますが、その大きさには現在の --help は入らないです。

もう一つの問題として、現在のオプションのリストはあたかも「これで
すべて」という印象を与えている。

「1画面」の話を保ちたいと思ったら、少なくとも 24x80 に完全に

入る用にして、新しく

--help-long        show all options

とかを追加しないと筋が通らないと思います。個人的には「1画面」に

こだわる必要がないと思います。

よろしくお願いします。      Martin.

At 22:58 09/01/21, you wrote:

チケット #1031 が更新されました。 (by Yui NARUSE)

ruby --help の結果は1画面に収まるべきであるという要求があったのと、

基本的に余計な情報は表には出さないという方針と、

両方の理由から特に --help に載せるべきものは厳選される傾向にあります。

http://redmine.ruby-lang.org/issues/show/1031

http://redmine.ruby-lang.org

 #-#-#  Martin J. Du"rst, Assoc. Professor, Aoyama Gakuin University

#-#-#  http://www.sw.it.aoyama.ac.jp       mailto:duerst@it.aoyama.ac.jp

=end

#5 - 01/22/2009 02:03 PM - shyouhei (Shyouhei Urabe)

- Category set to doc

- Assignee set to matz (Yukihiro Matsumoto)

=begin

縦は24行なので文面を調整すれば80文字に納めるのは可能でしょう。

いずれにせよ1画面にこだわってるのはまつもとさんなのでまつもとさんにassignしときますね。

=end

#6 - 01/22/2009 06:17 PM - matz (Yukihiro Matsumoto)

=begin

まつもと ゆきひろです

In message "Re: [ruby-dev:37818] [Bug #1031] -U  オプションの説明が --help  にない"

on Thu, 22 Jan 2009 14:02:11 +0900, Shyouhei Urabe redmine@ruby-lang.org writes:

|縦は24行なので文面を調整すれば80文字に納めるのは可能でしょう。

|いずれにせよ1画面にこだわってるのはまつもとさんなのでまつもとさんにassignしときますね。

引き受けました。文案の提案があるとありがたいです。

ruby-coreに聞いた方がいいかなあ。

=end

#7 - 04/11/2009 01:11 PM - sakuro (Sakuro OZAWA)

=begin

権限のある方、ステータスを Assigned に変更してください。

=end

#8 - 04/11/2009 03:42 PM - nobu (Nobuyoshi Nakada)

- Status changed from Rejected to Assigned

- Target version set to 1.9.2

- ruby -v set to 1.9.2dev

=begin
=end

#9 - 10/11/2009 01:16 AM - naruse (Yui NARUSE)

=begin

これってどうなってるんでしょう。

なお、担当者は Developer 以上にしかできないらしい。

=end

#10 - 03/25/2010 01:45 AM - mame (Yusuke Endoh)

=begin

遠藤です。

まつもと ゆきひろです

In message "Re: [ruby-dev:37818] [Bug #1031] -U  オプションの説明が --help  にない"

on Thu, 22 Jan 2009 14:02:11 +0900, Shyouhei Urabe redmine@ruby-lang.org writes:

|縦は24行なので文面を調整すれば80文字に納めるのは可能でしょう。

|いずれにせよ1画面にこだわってるのはまつもとさんなのでまつもとさんにassignしときますね。

引き受けました。文案の提案があるとありがたいです。

ruby-coreに聞いた方がいいかなあ。

 この件、どうなってるんでしょう。

「縦は24行なので文面を調整すれば80文字に納めるのは可能」とのこと

ですが、現在すでに 24 行使ってしまっていると思います。

$ ./ruby -h | wc -l

24

どういうことなんでしょう。当時はまだ余ってた？

--

Yusuke Endoh mame@tsg.ne.jp

=end

#11 - 03/25/2010 01:45 PM - shugo (Shugo Maeda)

=begin

前田です。

2010年3月25日1:45 Yusuke Endoh redmine@ruby-lang.org:

「縦は24行なので文面を調整すれば80文字に納めるのは可能」とのこと

ですが、現在すでに 24 行使ってしまっていると思います。

$ ./ruby -h | wc -l

24

どういうことなんでしょう。当時はまだ余ってた？

 シェルのプロンプトで一行使われることを考えると、現在の24行でもすでに80x24の

一画面には収まってないんじゃないでしょうか。

lessやlvでも23行しか表示できませんし。

--

Shugo Maeda

=end

#12 - 03/25/2010 03:12 PM - shyouhei (Shyouhei Urabe)

=begin

まあみんなでうなっててもしょうがないので改善案を出してみましょうか。

以下の例だと横79文字、縦22行です。

Usage:

ruby [options ...] -- script [script optoins...]

Options:
Please  consult the  online manual  for the  comprehensive list  of options

understood, but the most frequently used ones are:

 -0[n]       much like perl -0

 -a          much like perl -a

 -c          much like perl -c

 -d          muck like perl -d

 -e program  much like perl -e

 -F pattern  much like perl -F

 -i[ext]     much like perl -i

 -I dir      much like perl -I

 -l          much like perl -l

 -n          much like perl -n

 -p          much like perl -p

 -r lib      pre-require lib before running the script

 -T level    much like perl -T, but several levels are there.

 -v          much like perl -v

 -w          much like perl -w

 Attachment: signature.asc

=end

#13 - 03/25/2010 08:25 PM - shugo (Shugo Maeda)

=begin

前田です。

2010年3月25日15:11 Urabe Shyouhei shyouhei@ruby-lang.org:

まあみんなでうなっててもしょうがないので改善案を出してみましょうか。

以下の例だと横79文字、縦22行です。

 えっと、この出力を見てperl -hすると、結局perlの出力が24行を超えてしまうので、

対案として24行の制限を外すというのはどうでしょうか。

--

Shugo Maeda

=end

#14 - 04/14/2010 01:11 AM - mame (Yusuke Endoh)

=begin

遠藤です。

こんなしょうもないチケットはさっさと決めて閉じてほしい……。

2010年3月25日15:11 Urabe Shyouhei shyouhei@ruby-lang.org:

まあみんなでうなっててもしょうがないので改善案を出してみましょうか。

 ruby -h の想定ユーザは初心者とコマンドラインで作業する人なので、

掲載基準も「普通によく使われるオプション」と「ワンライナーでよく

使われるオプション」に限定したらいいと思いました。この基準で現在

掲載されているオプションを主観的に評価してみました。

○普通によく使われる

1 級: -e -I -r -v (-h)

2 級: -d -T -w -W

3 級: -E (-U)

○ワンライナーでよく使われる

1 級: -l -n -p

2 級: -0 -a -F -i

以上から、

ruby -h から -c -s -S -x --version を削除する

-U を追加する
でどうでしょう。--copyright は政治的な理由で必要かもしれないので

残しました (といってもまつもとさんの名前しか出ないので LEGAL の

代わりにはならないようですが) 。

diff --git a/ruby.c b/ruby.c

index 5c1eef0..2a36cb6 100644

--- a/ruby.c

+++ b/ruby.c

@@ -135,7 +135,6 @@ usage(const char *name)

static const char *const usage_msg[] = {

"-0[octal]       specify record separator (\0, if no argument)",

"-a              autosplit mode with -n or -p (splits $_ into $F)",

"-c              check syntax only",

"-Cdirectory     cd to directory, before executing your script",

"-d              set debugging flags (set $DEBUG to true)",

"-e 'command'    one line of script. Several -e's allowed. Omit [programfile]",

@@ -147,13 +146,11 @@ usage(const char *name)

"-n              assume 'while gets(); ... end' loop around your script",

"-p              assume loop like -n but print line also like sed",

"-rlibrary       require the library, before executing your script",

"-s              enable some switch parsing for switches after script name",

"-S              look for the script using PATH environment variable",

"-T[level=1]     turn on tainting checks",

"-U              set internal character encoding as UTF-8",

"-v              print version number, then turn on verbose mode",

"-w              turn warnings on for your script",

"-W[level=2]     set warning level; 0=silence, 1=medium, 2=verbose",

"-x[directory]   strip off text before #!ruby line and perhaps cd to directory",

"--copyright     print the copyright",

"--version       print the version",

NULL

--long-help なり -v -h なりが欲しい人は、自分で文案を作成して

提案すればいいと思います。

--

Yusuke ENDOH mame@tsg.ne.jp

=end

#15 - 05/10/2010 11:38 PM - mame (Yusuke Endoh)

- Priority changed from Normal to 3

=begin

=end

#16 - 07/17/2010 03:33 PM - yugui (Yuki Sonoda)

- Target version changed from 1.9.2 to 2.0.0

=begin

=end

#17 - 06/11/2011 02:17 PM - ko1 (Koichi Sasada)

まだ，閉じられていないようです...．

#18 - 06/24/2011 12:12 AM - naruse (Yui NARUSE)

- Tracker changed from Bug to Feature

とりあえずFeatureに移動しますかね

#19 - 02/08/2012 03:21 AM - kosaki (Motohiro KOSAKI)

- Status changed from Assigned to Rejected

非常に感じ悪い事は承知しているけど、長期間進展のない自転車置き場の議論は復活させるのも不毛なので問答無用で閉じます。問題意識のあるひとがパッチと共に新規チケットつくってほしいです。
Files

ruby.c.diff 622 Bytes 01/21/2009 sakuro (Sakuro OZAWA)
